Index: code/branches/physics/src/bullet/BulletSoftBody/btSoftBodyHelpers.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletSoftBody/btSoftBodyHelpers.cpp	(revision 1971)
+++ code/branches/physics/src/bullet/BulletSoftBody/btSoftBodyHelpers.cpp	(revision 1972)
@@ -23,55 +23,55 @@
 //
 static void				drawVertex(	btIDebugDraw* idraw,
-								   const btVector3& x,btScalar s,const btVector3& c)
-{
-	idraw->drawLine(x-btVector3(s,0,0),x+btVector3(s,0,0),c);
-	idraw->drawLine(x-btVector3(0,s,0),x+btVector3(0,s,0),c);
-	idraw->drawLine(x-btVector3(0,0,s),x+btVector3(0,0,s),c);
-}
+									const btVector3& x,btScalar s,const btVector3& c)
+	{
+		idraw->drawLine(x-btVector3(s,0,0),x+btVector3(s,0,0),c);
+		idraw->drawLine(x-btVector3(0,s,0),x+btVector3(0,s,0),c);
+		idraw->drawLine(x-btVector3(0,0,s),x+btVector3(0,0,s),c);
+	}
 
 //
 static void				drawBox(	btIDebugDraw* idraw,
-								const btVector3& mins,
-								const btVector3& maxs,
-								const btVector3& color)
-{
-	const btVector3	c[]={	btVector3(mins.x(),mins.y(),mins.z()),
-		btVector3(maxs.x(),mins.y(),mins.z()),
-		btVector3(maxs.x(),maxs.y(),mins.z()),
-		btVector3(mins.x(),maxs.y(),mins.z()),
-		btVector3(mins.x(),mins.y(),maxs.z()),
-		btVector3(maxs.x(),mins.y(),maxs.z()),
-		btVector3(maxs.x(),maxs.y(),maxs.z()),
-		btVector3(mins.x(),maxs.y(),maxs.z())};
-	idraw->drawLine(c[0],c[1],color);idraw->drawLine(c[1],c[2],color);
-	idraw->drawLine(c[2],c[3],color);idraw->drawLine(c[3],c[0],color);
-	idraw->drawLine(c[4],c[5],color);idraw->drawLine(c[5],c[6],color);
-	idraw->drawLine(c[6],c[7],color);idraw->drawLine(c[7],c[4],color);
-	idraw->drawLine(c[0],c[4],color);idraw->drawLine(c[1],c[5],color);
-	idraw->drawLine(c[2],c[6],color);idraw->drawLine(c[3],c[7],color);
+									const btVector3& mins,
+									const btVector3& maxs,
+									const btVector3& color)
+{
+const btVector3	c[]={	btVector3(mins.x(),mins.y(),mins.z()),
+						btVector3(maxs.x(),mins.y(),mins.z()),
+						btVector3(maxs.x(),maxs.y(),mins.z()),
+						btVector3(mins.x(),maxs.y(),mins.z()),
+						btVector3(mins.x(),mins.y(),maxs.z()),
+						btVector3(maxs.x(),mins.y(),maxs.z()),
+						btVector3(maxs.x(),maxs.y(),maxs.z()),
+						btVector3(mins.x(),maxs.y(),maxs.z())};
+idraw->drawLine(c[0],c[1],color);idraw->drawLine(c[1],c[2],color);
+idraw->drawLine(c[2],c[3],color);idraw->drawLine(c[3],c[0],color);
+idraw->drawLine(c[4],c[5],color);idraw->drawLine(c[5],c[6],color);
+idraw->drawLine(c[6],c[7],color);idraw->drawLine(c[7],c[4],color);
+idraw->drawLine(c[0],c[4],color);idraw->drawLine(c[1],c[5],color);
+idraw->drawLine(c[2],c[6],color);idraw->drawLine(c[3],c[7],color);
 }
 
 //
 static void				drawTree(	btIDebugDraw* idraw,
-								 const btDbvtNode* node,
-								 int depth,
-								 const btVector3& ncolor,
-								 const btVector3& lcolor,
-								 int mindepth,
-								 int maxdepth)
-{
-	if(node)
-	{
-		if(node->isinternal()&&((depth<maxdepth)||(maxdepth<0)))
-		{
-			drawTree(idraw,node->childs[0],depth+1,ncolor,lcolor,mindepth,maxdepth);
-			drawTree(idraw,node->childs[1],depth+1,ncolor,lcolor,mindepth,maxdepth);
-		}
-		if(depth>=mindepth)
-		{
-			const btScalar	scl=(btScalar)(node->isinternal()?1:1);
-			const btVector3	mi=node->volume.Center()-node->volume.Extents()*scl;
-			const btVector3	mx=node->volume.Center()+node->volume.Extents()*scl;
-			drawBox(idraw,mi,mx,node->isleaf()?lcolor:ncolor);
+									const btDbvtNode* node,
+									int depth,
+									const btVector3& ncolor,
+									const btVector3& lcolor,
+									int mindepth,
+									int maxdepth)
+{
+if(node)
+	{
+	if(node->isinternal()&&((depth<maxdepth)||(maxdepth<0)))
+		{
+		drawTree(idraw,node->childs[0],depth+1,ncolor,lcolor,mindepth,maxdepth);
+		drawTree(idraw,node->childs[1],depth+1,ncolor,lcolor,mindepth,maxdepth);
+		}
+	if(depth>=mindepth)
+		{
+		const btScalar	scl=(btScalar)(node->isinternal()?1:1);
+		const btVector3	mi=node->volume.Center()-node->volume.Extents()*scl;
+		const btVector3	mx=node->volume.Center()+node->volume.Extents()*scl;
+		drawBox(idraw,mi,mx,node->isleaf()?lcolor:ncolor);
 		}
 	}
@@ -82,14 +82,14 @@
 static inline T				sum(const btAlignedObjectArray<T>& items)
 {
-	T	v;
-	if(items.size())
-	{
-		v=items[0];
-		for(int i=1,ni=items.size();i<ni;++i)
-		{
-			v+=items[i];
-		}
-	}
-	return(v);
+T	v;
+if(items.size())
+	{
+	v=items[0];
+	for(int i=1,ni=items.size();i<ni;++i)
+		{
+		v+=items[i];
+		}
+	}
+return(v);
 }
 
@@ -98,7 +98,7 @@
 static inline void			add(btAlignedObjectArray<T>& items,const Q& value)
 {
-	for(int i=0,ni=items.size();i<ni;++i)
-	{
-		items[i]+=value;
+for(int i=0,ni=items.size();i<ni;++i)
+	{
+	items[i]+=value;
 	}
 }
@@ -108,7 +108,7 @@
 static inline void			mul(btAlignedObjectArray<T>& items,const Q& value)
 {
-	for(int i=0,ni=items.size();i<ni;++i)
-	{
-		items[i]*=value;
+for(int i=0,ni=items.size();i<ni;++i)
+	{
+	items[i]*=value;
 	}
 }
@@ -118,6 +118,6 @@
 static inline T				average(const btAlignedObjectArray<T>& items)
 {
-	const btScalar	n=(btScalar)(items.size()>0?items.size():1);
-	return(sum(items)/n);
+const btScalar	n=(btScalar)(items.size()>0?items.size():1);
+return(sum(items)/n);
 }
 
@@ -137,12 +137,12 @@
 #if 0
 static btVector3		stresscolor(btScalar stress)
-{
+	{
 	static const btVector3	spectrum[]=	{	btVector3(1,0,1),
-		btVector3(0,0,1),
-		btVector3(0,1,1),
-		btVector3(0,1,0),
-		btVector3(1,1,0),
-		btVector3(1,0,0),
-		btVector3(1,0,0)};
+											btVector3(0,0,1),
+											btVector3(0,1,1),
+											btVector3(0,1,0),
+											btVector3(1,1,0),
+											btVector3(1,0,0),
+											btVector3(1,0,0)};
 	static const int		ncolors=sizeof(spectrum)/sizeof(spectrum[0])-1;
 	static const btScalar	one=1;
@@ -151,11 +151,11 @@
 	const btScalar			frc=stress-sel;
 	return(spectrum[sel]+(spectrum[sel+1]-spectrum[sel])*frc);
-}
+	}
 #endif
 
 //
 void			btSoftBodyHelpers::Draw(	btSoftBody* psb,
-										btIDebugDraw* idraw,
-										int drawflags)
+					 btIDebugDraw* idraw,
+					 int drawflags)
 {
 	const btScalar		scl=(btScalar)0.1;
@@ -252,27 +252,27 @@
 			const btVector3			c=(x[0]+x[1]+x[2])/3;
 			idraw->drawTriangle((x[0]-c)*scl+c,
-				(x[1]-c)*scl+c,
-				(x[2]-c)*scl+c,
-				col,alp);
+								(x[1]-c)*scl+c,
+								(x[2]-c)*scl+c,
+								col,alp);
 		}	
 	}
 	/* Clusters	*/ 
 	if(0!=(drawflags&fDrawFlags::Clusters))
-	{
+		{
 		srand(1806);
 		for(i=0;i<psb->m_clusters.size();++i)
-		{
+			{
 			if(psb->m_clusters[i]->m_collide)
-			{
+				{
 				btVector3						color(	rand()/(btScalar)RAND_MAX,
-					rand()/(btScalar)RAND_MAX,
-					rand()/(btScalar)RAND_MAX);
+														rand()/(btScalar)RAND_MAX,
+														rand()/(btScalar)RAND_MAX);
 				color=color.normalized()*0.75;
 				btAlignedObjectArray<btVector3>	vertices;
 				vertices.resize(psb->m_clusters[i]->m_nodes.size());
 				for(j=0,nj=vertices.size();j<nj;++j)
-				{				
+					{				
 					vertices[j]=psb->m_clusters[i]->m_nodes[j]->m_x;
-				}
+					}
 				HullDesc		hdsc(QF_TRIANGLES,vertices.size(),&vertices[0]);
 				HullResult		hres;
@@ -285,23 +285,23 @@
 				add(hres.m_OutputVertices,center);
 				for(j=0;j<(int)hres.mNumFaces;++j)
-				{
+					{
 					const int idx[]={hres.m_Indices[j*3+0],hres.m_Indices[j*3+1],hres.m_Indices[j*3+2]};
 					idraw->drawTriangle(hres.m_OutputVertices[idx[0]],
-						hres.m_OutputVertices[idx[1]],
-						hres.m_OutputVertices[idx[2]],
-						color,1);
+										hres.m_OutputVertices[idx[1]],
+										hres.m_OutputVertices[idx[2]],
+										color,1);
+					}
+				hlib.ReleaseResult(hres);
 				}
-				hlib.ReleaseResult(hres);
-			}
 			/* Velocities	*/ 
-#if 0
+			#if 0
 			for(int j=0;j<psb->m_clusters[i].m_nodes.size();++j)
-			{
+				{
 				const btSoftBody::Cluster&	c=psb->m_clusters[i];
 				const btVector3				r=c.m_nodes[j]->m_x-c.m_com;
 				const btVector3				v=c.m_lv+cross(c.m_av,r);
 				idraw->drawLine(c.m_nodes[j]->m_x,c.m_nodes[j]->m_x+v,btVector3(1,0,0));
-			}
-#endif
+				}
+			#endif
 			/* Frame		*/ 
 			btSoftBody::Cluster& c=*psb->m_clusters[i];
@@ -309,6 +309,6 @@
 			idraw->drawLine(c.m_com,c.m_framexform*btVector3(0,10,0),btVector3(0,1,0));
 			idraw->drawLine(c.m_com,c.m_framexform*btVector3(0,0,10),btVector3(0,0,1));
-		}
-	}
+			}
+		}
 	/* Notes	*/ 
 	if(0!=(drawflags&fDrawFlags::Notes))
@@ -319,7 +319,7 @@
 			btVector3				p=n.m_offset;
 			for(int j=0;j<n.m_rank;++j)
-			{
+				{
 				p+=n.m_nodes[j]->m_x*n.m_coords[j];
-			}
+				}
 			idraw->draw3dText(p,n.m_text);
 		}
@@ -334,31 +334,31 @@
 	if(0!=(drawflags&fDrawFlags::Joints))
 	{
-		for(i=0;i<psb->m_joints.size();++i)
-		{
-			const btSoftBody::Joint*	pj=psb->m_joints[i];
-			switch(pj->Type())
+	for(i=0;i<psb->m_joints.size();++i)
+		{
+		const btSoftBody::Joint*	pj=psb->m_joints[i];
+		switch(pj->Type())
 			{
 			case	btSoftBody::Joint::eType::Linear:
 				{
-					const btSoftBody::LJoint*	pjl=(const btSoftBody::LJoint*)pj;
-					const btVector3	a0=pj->m_bodies[0].xform()*pjl->m_refs[0];
-					const btVector3	a1=pj->m_bodies[1].xform()*pjl->m_refs[1];
-					idraw->drawLine(pj->m_bodies[0].xform().getOrigin(),a0,btVector3(1,1,0));
-					idraw->drawLine(pj->m_bodies[1].xform().getOrigin(),a1,btVector3(0,1,1));
-					drawVertex(idraw,a0,0.25,btVector3(1,1,0));
-					drawVertex(idraw,a1,0.25,btVector3(0,1,1));
+				const btSoftBody::LJoint*	pjl=(const btSoftBody::LJoint*)pj;
+				const btVector3	a0=pj->m_bodies[0].xform()*pjl->m_refs[0];
+				const btVector3	a1=pj->m_bodies[1].xform()*pjl->m_refs[1];
+				idraw->drawLine(pj->m_bodies[0].xform().getOrigin(),a0,btVector3(1,1,0));
+				idraw->drawLine(pj->m_bodies[1].xform().getOrigin(),a1,btVector3(0,1,1));
+				drawVertex(idraw,a0,0.25,btVector3(1,1,0));
+				drawVertex(idraw,a1,0.25,btVector3(0,1,1));
 				}
-				break;
+			break;
 			case	btSoftBody::Joint::eType::Angular:
 				{
-					const btSoftBody::AJoint*	pja=(const btSoftBody::AJoint*)pj;
-					const btVector3	o0=pj->m_bodies[0].xform().getOrigin();
-					const btVector3	o1=pj->m_bodies[1].xform().getOrigin();
-					const btVector3	a0=pj->m_bodies[0].xform().getBasis()*pj->m_refs[0];
-					const btVector3	a1=pj->m_bodies[1].xform().getBasis()*pj->m_refs[1];
-					idraw->drawLine(o0,o0+a0*10,btVector3(1,1,0));
-					idraw->drawLine(o0,o0+a1*10,btVector3(1,1,0));
-					idraw->drawLine(o1,o1+a0*10,btVector3(0,1,1));
-					idraw->drawLine(o1,o1+a1*10,btVector3(0,1,1));
+				const btSoftBody::AJoint*	pja=(const btSoftBody::AJoint*)pj;
+				const btVector3	o0=pj->m_bodies[0].xform().getOrigin();
+				const btVector3	o1=pj->m_bodies[1].xform().getOrigin();
+				const btVector3	a0=pj->m_bodies[0].xform().getBasis()*pj->m_refs[0];
+				const btVector3	a1=pj->m_bodies[1].xform().getBasis()*pj->m_refs[1];
+				idraw->drawLine(o0,o0+a0*10,btVector3(1,1,0));
+				idraw->drawLine(o0,o0+a1*10,btVector3(1,1,0));
+				idraw->drawLine(o1,o1+a0*10,btVector3(0,1,1));
+				idraw->drawLine(o1,o1+a1*10,btVector3(0,1,1));
 				}
 			}		
@@ -369,8 +369,8 @@
 //
 void			btSoftBodyHelpers::DrawInfos(		btSoftBody* psb,
-											 btIDebugDraw* idraw,
-											 bool masses,
-											 bool areas,
-											 bool /*stress*/)
+						  btIDebugDraw* idraw,
+						  bool masses,
+						  bool areas,
+						  bool /*stress*/)
 {
 	for(int i=0;i<psb->m_nodes.size();++i)
@@ -395,32 +395,32 @@
 //
 void			btSoftBodyHelpers::DrawNodeTree(	btSoftBody* psb,
-												btIDebugDraw* idraw,
-												int mindepth,
-												int maxdepth)
-{
-	drawTree(idraw,psb->m_ndbvt.m_root,0,btVector3(1,0,1),btVector3(1,1,1),mindepth,maxdepth);
+													btIDebugDraw* idraw,
+													int mindepth,
+													int maxdepth)
+{
+drawTree(idraw,psb->m_ndbvt.m_root,0,btVector3(1,0,1),btVector3(1,1,1),mindepth,maxdepth);
 }
 
 //
 void			btSoftBodyHelpers::DrawFaceTree(	btSoftBody* psb,
-												btIDebugDraw* idraw,
-												int mindepth,
-												int maxdepth)
-{
-	drawTree(idraw,psb->m_fdbvt.m_root,0,btVector3(0,1,0),btVector3(1,0,0),mindepth,maxdepth);
+													btIDebugDraw* idraw,
+													int mindepth,
+													int maxdepth)
+{
+drawTree(idraw,psb->m_fdbvt.m_root,0,btVector3(0,1,0),btVector3(1,0,0),mindepth,maxdepth);
 }
 
 //
 void			btSoftBodyHelpers::DrawClusterTree(	btSoftBody* psb,
-												   btIDebugDraw* idraw,
-												   int mindepth,
-												   int maxdepth)
-{
-	drawTree(idraw,psb->m_cdbvt.m_root,0,btVector3(0,1,1),btVector3(1,0,0),mindepth,maxdepth);
+													btIDebugDraw* idraw,
+													int mindepth,
+													int maxdepth)
+{
+drawTree(idraw,psb->m_cdbvt.m_root,0,btVector3(0,1,1),btVector3(1,0,0),mindepth,maxdepth);
 }
 
 //
 void			btSoftBodyHelpers::DrawFrame(		btSoftBody* psb,
-											 btIDebugDraw* idraw)
+						  btIDebugDraw* idraw)
 {
 	if(psb->m_pose.m_bframe)
@@ -446,7 +446,7 @@
 //
 btSoftBody*		btSoftBodyHelpers::CreateRope(	btSoftBodyWorldInfo& worldInfo, const btVector3& from,
-											  const btVector3& to,
-											  int res,
-											  int fixeds)
+						   const btVector3& to,
+						   int res,
+						   int fixeds)
 {
 	/* Create nodes	*/ 
@@ -478,11 +478,11 @@
 //
 btSoftBody*		btSoftBodyHelpers::CreatePatch(btSoftBodyWorldInfo& worldInfo,const btVector3& corner00,
-											   const btVector3& corner10,
-											   const btVector3& corner01,
-											   const btVector3& corner11,
-											   int resx,
-											   int resy,
-											   int fixeds,
-											   bool gendiags)
+							const btVector3& corner10,
+							const btVector3& corner01,
+							const btVector3& corner11,
+							int resx,
+							int resy,
+							int fixeds,
+							bool gendiags)
 {
 #define IDX(_x_,_y_)	((_y_)*rx+(_x_))
@@ -554,211 +554,7 @@
 
 //
-btSoftBody*		btSoftBodyHelpers::CreatePatchUV(btSoftBodyWorldInfo& worldInfo,
-												 const btVector3& corner00,
-												 const btVector3& corner10,
-												 const btVector3& corner01,
-												 const btVector3& corner11,
-												 int resx,
-												 int resy,
-												 int fixeds,
-												 bool gendiags,
-												 float* tex_coords)
-{
-
-	/*
-	*
-	*  corners:
-	*
-	*  [0][0]     corner00 ------- corner01   [resx][0]
-	*                |                |
-	*                |                |
-	*  [0][resy]  corner10 -------- corner11  [resx][resy]
-	*
-	*
-	*
-	*
-	*
-	*
-	*   "fixedgs" map:
-	*
-	*  corner00     -->   +1
-	*  corner01     -->   +2
-	*  corner10     -->   +4
-	*  corner11     -->   +8
-	*  upper middle -->  +16
-	*  left middle  -->  +32
-	*  right middle -->  +64
-	*  lower middle --> +128
-	*  center       --> +256
-	*
-	*
-	*   tex_coords size   (resx-1)*(resy-1)*12
-	*
-	*
-	*
-	*     SINGLE QUAD INTERNALS
-	*
-	*  1) btSoftBody's nodes and links,
-	*     diagonal link is optional ("gendiags")
-	*
-	*
-	*    node00 ------ node01
-	*      | .              
-	*      |   .            
-	*      |     .          
-	*      |       .        
-	*      |         .      
-	*    node10        node11
-	*
-	*
-	*
-	*   2) Faces:
-	*      two triangles,
-	*      UV Coordinates (hier example for single quad)
-	*      
-	*     (0,1)          (0,1)  (1,1)
-	*     1 |\            3 \-----| 2
-	*       | \              \    |
-	*       |  \              \   |
-	*       |   \              \  |
-	*       |    \              \ |
-	*     2 |-----\ 3            \| 1
-	*     (0,0)    (1,0)       (1,0)
-	*
-	*
-	*
-	*
-	*
-	*
-	*/
-
-#define IDX(_x_,_y_)	((_y_)*rx+(_x_))
-	/* Create nodes		*/ 
-	if((resx<2)||(resy<2)) return(0);
-	const int	rx=resx;
-	const int	ry=resy;
-	const int	tot=rx*ry;
-	btVector3*	x=new btVector3[tot];
-	btScalar*	m=new btScalar[tot];
-
-	for(int iy=0;iy<ry;++iy)
-	{
-		const btScalar	ty=iy/(btScalar)(ry-1);
-		const btVector3	py0=lerp(corner00,corner01,ty);
-		const btVector3	py1=lerp(corner10,corner11,ty);
-		for(int ix=0;ix<rx;++ix)
-		{
-			const btScalar	tx=ix/(btScalar)(rx-1);
-			x[IDX(ix,iy)]=lerp(py0,py1,tx);
-			m[IDX(ix,iy)]=1;
-		}
-	}
-	btSoftBody*	psb=new btSoftBody(&worldInfo,tot,x,m);
-	if(fixeds&1)		psb->setMass(IDX(0,0),0);
-	if(fixeds&2)		psb->setMass(IDX(rx-1,0),0);
-	if(fixeds&4)		psb->setMass(IDX(0,ry-1),0);
-	if(fixeds&8)		psb->setMass(IDX(rx-1,ry-1),0);
-	if(fixeds&16)		psb->setMass(IDX((rx-1)/2,0),0);
-	if(fixeds&32)		psb->setMass(IDX(0,(ry-1)/2),0);
-	if(fixeds&64)		psb->setMass(IDX(rx-1,(ry-1)/2),0);
-	if(fixeds&128)		psb->setMass(IDX((rx-1)/2,ry-1),0);
-	if(fixeds&256)		psb->setMass(IDX((rx-1)/2,(ry-1)/2),0);
-	delete[] x;
-	delete[] m;
-
-
-	int z = 0;
-	/* Create links	and faces	*/ 
-	for(int iy=0;iy<ry;++iy)
-	{
-		for(int ix=0;ix<rx;++ix)
-		{
-			const bool	mdx=(ix+1)<rx;
-			const bool	mdy=(iy+1)<ry;
-
-			int node00=IDX(ix,iy);
-			int node01=IDX(ix+1,iy);
-			int node10=IDX(ix,iy+1);
-			int node11=IDX(ix+1,iy+1);
-
-			if(mdx) psb->appendLink(node00,node01);
-			if(mdy) psb->appendLink(node00,node10);
-			if(mdx&&mdy)
-			{
-				psb->appendFace(node00,node10,node11);
-				if (tex_coords) {
-					tex_coords[z+0]=CalculateUV(resx,resy,ix,iy,0);
-					tex_coords[z+1]=CalculateUV(resx,resy,ix,iy,1);
-					tex_coords[z+2]=CalculateUV(resx,resy,ix,iy,0);
-					tex_coords[z+3]=CalculateUV(resx,resy,ix,iy,2);
-					tex_coords[z+4]=CalculateUV(resx,resy,ix,iy,3);
-					tex_coords[z+5]=CalculateUV(resx,resy,ix,iy,2);
-				}
-				psb->appendFace(node11,node01,node00);
-				if (tex_coords) {
-					tex_coords[z+6 ]=CalculateUV(resx,resy,ix,iy,3);
-					tex_coords[z+7 ]=CalculateUV(resx,resy,ix,iy,2);
-					tex_coords[z+8 ]=CalculateUV(resx,resy,ix,iy,3);
-					tex_coords[z+9 ]=CalculateUV(resx,resy,ix,iy,1);
-					tex_coords[z+10]=CalculateUV(resx,resy,ix,iy,0);
-					tex_coords[z+11]=CalculateUV(resx,resy,ix,iy,1);
-				}
-				if (gendiags) psb->appendLink(node00,node11);
-				z += 12;
-			}
-		}
-	}
-	/* Finished	*/ 
-#undef IDX
-	return(psb);
-}
-
-float   btSoftBodyHelpers::CalculateUV(int resx,int resy,int ix,int iy,int id)
-{
-
-	/*
-	*
-	*
-	*    node00 --- node01
-	*      |          |
-	*    node10 --- node11
-	*
-	*
-	*   ID map:
-	*
-	*   node00 s --> 0
-	*   node00 t --> 1
-	*
-	*   node01 s --> 3
-	*   node01 t --> 1
-	*
-	*   node10 s --> 0
-	*   node10 t --> 2
-	*
-	*   node11 s --> 3
-	*   node11 t --> 2
-	*
-	*
-	*/
-
-	float tc=0.0f;
-	if (id == 0) {
-		tc = (1.0f/((resx-1))*ix);
-	}
-	else if (id==1) {
-		tc = (1.0f/((resy-1))*(resy-1-iy));
-	}
-	else if (id==2) {
-		tc = (1.0f/((resy-1))*(resy-1-iy-1));
-	}
-	else if (id==3) {
-		tc = (1.0f/((resx-1))*(ix+1));
-	}
-	return tc;
-}
-//
 btSoftBody*		btSoftBodyHelpers::CreateEllipsoid(btSoftBodyWorldInfo& worldInfo,const btVector3& center,
-												   const btVector3& radius,
-												   int res)
+								const btVector3& radius,
+								int res)
 {
 	struct	Hammersley
@@ -791,6 +587,6 @@
 //
 btSoftBody*		btSoftBodyHelpers::CreateFromTriMesh(btSoftBodyWorldInfo& worldInfo,const btScalar*	vertices,
-													 const int* triangles,
-													 int ntriangles)
+								  const int* triangles,
+								  int ntriangles)
 {
 	int		maxidx=0;
@@ -833,5 +629,5 @@
 //
 btSoftBody*		btSoftBodyHelpers::CreateFromConvexHull(btSoftBodyWorldInfo& worldInfo,	const btVector3* vertices,
-														int nvertices)
+									 int nvertices)
 {
 	HullDesc		hdsc(QF_TRIANGLES,nvertices,vertices);
Index: code/branches/physics/src/bullet/BulletSoftBody/btSoftBodyHelpers.h
===================================================================
--- code/branches/physics/src/bullet/BulletSoftBody/btSoftBodyHelpers.h	(revision 1971)
+++ code/branches/physics/src/bullet/BulletSoftBody/btSoftBodyHelpers.h	(revision 1972)
@@ -47,72 +47,60 @@
 	/* Draw body															*/ 
 	static void				Draw(		btSoftBody* psb,
-		btIDebugDraw* idraw,
-		int drawflags=fDrawFlags::Std);
+										btIDebugDraw* idraw,
+										int drawflags=fDrawFlags::Std);
 	/* Draw body infos														*/ 
 	static	void			DrawInfos(	btSoftBody* psb,
-		btIDebugDraw* idraw,
-		bool masses,
-		bool areas,
-		bool stress);
+										btIDebugDraw* idraw,
+										bool masses,
+										bool areas,
+										bool stress);
 	/* Draw node tree														*/ 
 	static void				DrawNodeTree(	btSoftBody* psb,
-		btIDebugDraw* idraw,
-		int mindepth=0,
-		int maxdepth=-1);
+											btIDebugDraw* idraw,
+											int mindepth=0,
+											int maxdepth=-1);
 	/* Draw face tree														*/ 
 	static void				DrawFaceTree(	btSoftBody* psb,
-		btIDebugDraw* idraw,
-		int mindepth=0,
-		int maxdepth=-1);
+											btIDebugDraw* idraw,
+											int mindepth=0,
+											int maxdepth=-1);
 	/* Draw cluster tree													*/ 
 	static void				DrawClusterTree(btSoftBody* psb,
-		btIDebugDraw* idraw,
-		int mindepth=0,
-		int maxdepth=-1);
+											btIDebugDraw* idraw,
+											int mindepth=0,
+											int maxdepth=-1);
 	/* Draw rigid frame														*/ 
 	static	void			DrawFrame(		btSoftBody* psb,
-		btIDebugDraw* idraw);
+											btIDebugDraw* idraw);
 	/* Create a rope														*/ 
 	static	btSoftBody*		CreateRope( btSoftBodyWorldInfo& worldInfo,
-		const btVector3& from,
-		const btVector3& to,
-		int res,
-		int fixeds);
+										const btVector3& from,
+										const btVector3& to,
+										int res,
+										int fixeds);
 	/* Create a patch														*/ 
 	static	btSoftBody*		CreatePatch(btSoftBodyWorldInfo& worldInfo,
-		const btVector3& corner00,
-		const btVector3& corner10,
-		const btVector3& corner01,
-		const btVector3& corner11,
-		int resx,
-		int resy,
-		int fixeds,
-		bool gendiags);
-	/* Create a patch with UV Texture Coordinates	*/ 
-	static	btSoftBody*		CreatePatchUV(btSoftBodyWorldInfo& worldInfo,
-		const btVector3& corner00,
-		const btVector3& corner10,
-		const btVector3& corner01,
-		const btVector3& corner11,
-		int resx,
-		int resy,
-		int fixeds,
-		bool gendiags,
-		float* tex_coords=0);
-	static	float	CalculateUV(int resx,int resy,int ix,int iy,int id);
+										const btVector3& corner00,
+										const btVector3& corner10,
+										const btVector3& corner01,
+										const btVector3& corner11,
+										int resx,
+										int resy,
+										int fixeds,
+										bool gendiags);
 	/* Create an ellipsoid													*/ 
 	static	btSoftBody*		CreateEllipsoid(btSoftBodyWorldInfo& worldInfo,
-		const btVector3& center,
-		const btVector3& radius,
-		int res);	
+											const btVector3& center,
+											const btVector3& radius,
+											int res);	
 	/* Create from trimesh													*/ 
 	static	btSoftBody*		CreateFromTriMesh(	btSoftBodyWorldInfo& worldInfo,
-		const btScalar*	vertices,
-		const int* triangles,
-		int ntriangles);
+												const btScalar*	vertices,
+												const int* triangles,
+												int ntriangles);
 	/* Create from convex-hull												*/ 
 	static	btSoftBody*		CreateFromConvexHull(	btSoftBodyWorldInfo& worldInfo,
-		const btVector3* vertices,
-		int nvertices);
+													const btVector3* vertices,
+													int nvertices);
 };
 
Index: code/branches/physics/src/bullet/CMakeLists.txt
===================================================================
--- code/branches/physics/src/bullet/CMakeLists.txt	(revision 1971)
+++ code/branches/physics/src/bullet/CMakeLists.txt	(revision 1972)
@@ -1,5 +1,6 @@
-if (CMAKE_SIZEOF_VOID_P MATCHES "8")
-  SUBDIRS( BulletSoftBody BulletCollision BulletDynamics LinearMath )
-else (CMAKE_SIZEOF_VOID_P MATCHES "8")
-  SUBDIRS( BulletMultiThreaded BulletSoftBody BulletCollision BulletDynamics LinearMath )
-endif (CMAKE_SIZEOF_VOID_P MATCHES "8")
+INCLUDE_DIRECTORIES(.)
+
+ADD_SUBDIRECTORY(BulletSoftBody)
+ADD_SUBDIRECTORY(BulletCollision)
+ADD_SUBDIRECTORY(BulletDynamics)
+ADD_SUBDIRECTORY(BulletLinearMath)
Index: code/branches/physics/src/bullet/ChangeLog
===================================================================
--- code/branches/physics/src/bullet/ChangeLog	(revision 1971)
+++ code/branches/physics/src/bullet/ChangeLog	(revision 1972)
@@ -5,6 +5,4 @@
 See http://code.google.com/p/bullet/source/list for more complete log in Subversion
 
-2008 October 10
-	- Moved aabb to btBroadphaseProxy, improves rayTest dramatically. Further raytest improvements using the broadphase acceleration structures are planned
 
 2008 October 3
Index: code/branches/physics/src/bullet/LinearMath/btScalar.h
===================================================================
--- code/branches/physics/src/bullet/LinearMath/btScalar.h	(revision 1971)
+++ code/branches/physics/src/bullet/LinearMath/btScalar.h	(revision 1972)
@@ -25,5 +25,5 @@
 #include <float.h>
 
-#define BT_BULLET_VERSION 273
+#define BT_BULLET_VERSION 272
 
 inline int	btGetVersion()
